## libosl 0.3.0

=== Makefile ===
-include makefile.local
include makefile.conf
ETAGS ?= etags

all : third-party
	$(MAKE) -C lib
	$(MAKE) -C test
	$(MAKE) -C sample
third-party: lib/third_party/$(GTEST)/Makefile lib/third_party/$(PROTOBUF)/Makefile
ifeq ($(USE_TCMALLOC),1)
	$(MAKE) -C lib/third_party/$(TCMALLOC)
endif
	$(MAKE) -C lib/third_party/$(GTEST)
	$(MAKE) -C lib/third_party/$(PROTOBUF)

prof : 
	$(MAKE) PROFILE=true -C lib

clean:
	$(MAKE) -C lib clean
	$(MAKE) -C release clean
	$(MAKE) -C profile clean
	$(MAKE) -C test clean
	$(MAKE) -C sample clean
	$(MAKE) -C doc clean
cleandeps:
	rm -rf lib/.deps lib/.objs lib/lib*.a
	rm -rf release/.deps release/.objs release/lib*.a
	rm -rf profile/.deps profile/.objs profile/lib*.a
	rm -rf sample/.deps sample/.objs
	rm -rf test/.deps test/.objs

tags:
	-rm TAGS
	for d in include/osl lib; do \
          find $$d \( -name "*.h" -o -name "*.cc" -o -name "*.tcc" \) -exec $(ETAGS) --append --language=c++ {} \;; \
	done
html:
	cd doc; $(MAKE)

lib/third_party/$(GTEST)/Makefile: lib/third_party/$(GTEST)/configure
	cd lib/third_party/$(GTEST); env CXX=$(CXX) ./configure 
lib/third_party/$(PROTOBUF)/Makefile: lib/third_party/$(PROTOBUF)/configure
	cd lib/third_party/$(PROTOBUF); env CXX=$(CXX) ./configure 

add-utf-8-bom:
	find . \( -name "*.h" -o -name "*.tcc" -o -name "*.cc" \) -exec nkf -w8 --overwrite {} \;

remove-utf-8-bom:
	find . \( -name "*.h" -o -name "*.tcc" -o -name "*.cc" \) -exec nkf -w --overwrite {} \;

=== lib/Makefile ===
OSL_HOME = ..
-include makefile.local
-include $(OSL_HOME)/makefile.local
include $(OSL_HOME)/makefile.conf

# type (cd osl/release; make) to build optimized library
ifdef RELEASE
else
DEBUG=t
endif

ifdef DEBUG
CXXOPTFLAGS ?= -O -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS) -DNDEBUG
endif

WARNING_FLAGS += -Werror
ifneq ($(CXX),icc)
## gcc
ifdef RELEASE
WARNING_FLAGS += $(WARN_INLINE)
ifndef PROFILE
CXXOPTFLAGS += -fomit-frame-pointer
endif
else
OTHERFLAGS = $(DEBUGFLAGS)
WARNING_FLAGS += -Wunused-parameter
endif
endif
OTHERFLAGS += -pipe $(CPUOPTION)

OSL_HOME_FLAGS = -DOSL_HOME=\"$(shell dirname `pwd`)\"
CXXFLAGS = $(OSL_HOME_FLAGS) $(CXXOPTFLAGS) $(OTHERFLAGS) \
	$(WARNING_FLAGS) $(PROF) $(GCH_INCLUDES) $(INCLUDES)

# all : update-headers clean-objects
all : update-headers 
	$(MAKE) $(LIBOSL_BOARD)
	$(MAKE) $(LIBOSL_SEARCH)

OBJS = 	$(LIB_BOARD_OBJS) $(LIB_SEARCH_OBJS)
LIB_BOARD_OBJS = \
	$(patsubst %.o,move_generator/%.o,$(MOVE_GENERATOR_OBJS)) \
	$(patsubst %.o,move_classifier/%.o,$(MOVE_CLASSIFIER_OBJS)) \
	$(patsubst %.o,record/%.o,$(RECORD_OBJS)) \
	$(patsubst %.o,stat/%.o,$(STAT_OBJS)) \
	$(patsubst %.o,effect_util/%.o,$(EFFECT_UTIL_OBJS)) \
	$(patsubst %.o,threatmate/%.o,$(THREATMATE_OBJS))  \
	$(EXCEPTIONAL_SEARCH_OBJS) \
	$(BASIC_OBJS)
LIB_SEARCH_OBJS = \
	$(patsubst %.o,rating/%.o,$(RATING_OBJS)) \
	$(patsubst %.o,search/%.o,$(SEARCH_OBJS)) \
	$(patsubst %.o,checkmate/%.o,$(CHECKMATE_OBJS)) \
	$(patsubst %.o,game_playing/%.o,$(GAME_PLAYING_OBJS)) \
	$(patsubst %.o,annotate/%.o,$(ANNOTATE_OBJS)) \
	c/facade.o

ifdef USE_NTESUKI
 LIB_SEARCH_OBJS += $(patsubst %.o,ntesuki/%.o,$(NTESUKI_OBJS)) 
endif

BASIC_OBJS = stl/pool_allocator.o \
	hash/boardKey.o hash/hashKey.o hash/hashKeyStack.o \
	hash/hashRandom.o \
	effect/numBitmapEffect.o effect/boardBitMask.o \
	effect/liberty8.o effect/liberty8Table.o effect/moveSignature.o \
	effect/numSimpleEffect.o \
	effect/effectedNumTable.o \
	effect/signatureEffect.o \
	mobility/mobilityTable.o \
	container/bitXmask.o container/pieceMask.o container/moveStack.o \
	container/moveVector.o container/moveLogProbVector.o \
	container/pieceVector.o container/ptypeOPositionVector.o \
	container/nearMask.o container/pieceValues.o container/position8.o \
	container/boardMask.o container/tripleInt.o \
	eval/pieceEval.o eval/progressEval.o eval/see.o \
	eval/endgame/attackKing.o eval/endgame/defenseKing.o \
	eval/endgame/kingPieceTable.o eval/endgame/attackDefense.o \
	eval/ppair/piecePairRawTable.o eval/ppair/piecePairPieceTable.o \
	eval/ppair/piecePairEvalBase.o \
	eval/ml/weights.o \
	eval/ml/piecePair.o eval/ml/piecePairKing.o \
	eval/ml/openMidEndingEval.o eval/ml/pieceEval.o \
	eval/ml/pin.o eval/ml/pieceStand.o \
	eval/ml/mobility.o eval/ml/kingTable.o \
	eval/ml/king8.o eval/ml/minorPiece.o \
	eval/ml/majorPiece.o eval/ml/progress.o \
	state/numEffectState.o state/simpleState.o \
	state/historyState.o \
	progress/ptypeProgress.o progress/effect5x3.o \
	progress/effect5x3d.o progress/effect5x3Table.o \
	progress/ml/newProgress.o \
	ptypeList.o ptype.o position.o player.o piece.o \
	offset.o offset32.o pieceTable.o boardTable.o ptypeTable.o \
	move.o direction.o  positionCompressor.o sennichite.o \
	centering3x3.o centering5x3.o \
	moveLogProb.o pieceStand.o pieceStandIO.o pathEncoding.o \
	tables.o repetitionCounter.o oslConfig.o \
	misc/mask.o misc/trace.o misc/milliSeconds.o misc/random.o misc/perfmon.o \
	misc/nonBlockDelete.o misc/align16New.o \
	misc/ncores.o misc/base64.o misc/ctime.o misc/fastCopier.o\
	misc/log/htmlPerformanceLog.o misc/log/textPerformanceLog.o \
	misc/sjis2euc.o misc/iconvConvert.o \
	enter_king/enterKing.o
# LIB_SEARCH_OBJS の方が相応しいがtables.ccの関係で LIB_BOARD_OBJS に
# 入れる必要があるもの
EXCEPTIONAL_SEARCH_OBJS = \
	checkmate/immediateCheckmateTable.o checkmate/proofNumberTable.o  \
	checkmate/king8Info.o

MOVE_GENERATOR_OBJS = open.o drop.o allMoves.o escape_.o \
	pieceOnBoard.o capture_.o promote_.o legalMoves.o \
	addEffect8.o addEffect8Table.o attackToPinned.o additionalLance.o \
	addEffectWithEffect.o 
# addEffect_.o addEffectTable.o 
MOVE_CLASSIFIER_OBJS = check_.o safeMove.o kingOpenMove.o \
	blockLongEffect.o trapRook.o canAttackInNMoves.o 
RECORD_OBJS = record.o csa.o csaString.o kisen.o opening/openingBook.o psn.o \
	csaRecord.o compactBoard.o miniBoard.o kanjiPrint.o usi.o kanjiMove.o \
	ki2.o checkDuplicate.o kakinoki.o miniBoardChar50.o myshogi.o
SEARCH_OBJS = killerMoveTable.o bigramKillerMove.o quiescenceSearch2.o \
	searchRecorder.o sortCaptureMoves.o \
	simpleHashTable.o quiescenceGenerator.o timeControl.o \
	threatmateState.o dualThreatmateState.o \
	searchState2.o searchTimer.o historyTable.o \
	breakThreatmate.o usiReporter.o searchMonitor.o \
	simpleHashRecord.o quiescenceRecord.o \
	alphaBeta2.o alphaBeta2Parallel.o moveGenerator.o \
	alphaBeta3.o hashRejections.o moveWithComment.o \
	moveStackRejections.o \
	analyzer/recordSet_.o analyzer/categoryMoveVector.o \
	quiescenceLog.o recordStack.o \
	analyzer/dotWriter.o analyzer/logWriter.o 
CHECKMATE_OBJS = pieceCost.o proofTreeDepthDfpn.o \
	fixedDepthSearcher.o \
	fixedDepthSearcher2.o\
	proofDisproof.o \
	limitToCheckCount.o dfpn.o dualDfpn.o dfpnParallel.o \
	checkmateIfCapture.o immediateCheckmate.o 
NTESUKI_OBJS = ntesukiRecord.o ntesukiTable.o ntesukiMove.o ntesukiMoveList.o ntesukiMoveGenerator.o \
	ntesukiSearcher.o ntesukiSimulationSearcher.o oracleProverLight.o \
	ntesukiMoveGenerator.o
RATING_OBJS = feature.o group.o featureSet.o \
	ratedMove.o ratedMoveVector.o ratingEnv.o \
	feature/pattern.o feature/capture.o feature/checkmate.o feature/position.o \
	feature/countEffect2.o feature/bigramAttack.o feature/king8.o \
	group/bigramGroup.o group/captureGroup.o group/positionGroup.o \
	group/patternGroup.o group/escape.o group/king8Group.o bradleyTerry.o 
STAT_OBJS = twoDimensionalStatistics.o histogram.o ratio.o 
EFFECT_UTIL_OBJS = additionalEffect.o effectUtil.o shadowEffect.o \
	neighboring8Direct.o neighboring25Direct.o sendOffPosition.o \
	neighboring8Effect.o pin.o virtualPin.o
GAME_PLAYING_OBJS = gameState.o computerPlayer.o csaLogger.o \
	gameManager.o gnuShogiClient.o csaClient.o cuiClient.o \
	openingBookTracer.o winCountTracer.o recordTracer.o \
	alphaBetaPlayer.o bookPlayer.o timeKeeper.o \
	csaTime.o weightTracer.o historyToTable.o searchPlayer.o \
	speculativeSearchPlayer.o speculativeModel.o \
	speculativeAllMoves.o 
ANNOTATE_OBJS = analyzer.o facade.o analysesResult.o
THREATMATE_OBJS = kfendPredictor.o richPredictor.o treePredictor.o mlPredictor.o 

SRCS = $(patsubst %.o,%.cc,$(OBJS))
DEPS = $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

ifeq ($(USE_GCH),yes)
HEADER_DEPS = $(patsubst %,.deps/%.d,$(HEADERS))
endif

-include $(DEPS) $(HEADER_DEPS)

libosl_board.a : $(LIB_BOARD_OBJS)
libosl_search.a : $(LIB_SEARCH_OBJS)
libosl_%.a:
	-mkdir .objs
	(cd .objs; for o in $^; do \
	  target=`echo $$o|sed -e 's/\//-/g'`; \
	  if [ ! -f $$target ]; then \
	    ln -s ../$$o $$target; \
	  fi; \
	done)
	$(ARC) $@ $(patsubst %,.objs/%,$(subst /,-,$^))
	-$(RANLIB) $@

### 今まであったファイルが消えた時に必要 (ファイル名の変更など)
light-clean:
	-rm -rf .deps .objs .gch 
	-rm -f *.a
### バイナリ互換性がなくなった時に必要 (gcc のバージョンアップなど)
clean: light-clean
	-rm $(OBJS)
distclean: clean 
	rm -f *~

ifeq ($(USE_GCH),yes)
update-headers: $(patsubst %,.gch/%.gch,$(HEADERS))
else
update-headers: 
endif

clean-objects:
	if [ -f oslConfig.o ]; then rm oslConfig.o; fi

=== release-so/Makefile ===
RELEASE = true
vpath %.cc ../lib

include ../lib/Makefile

OTHERFLAGS += -fPIC

libosl.so.1.0: $(OBJS)
	-mkdir .objs
	(cd .objs; for o in $^; do \
	  target=`echo $$o|sed -e 's/\//-/g'`; \
	  if [ ! -f $$target ]; then \
	    ln -s ../$$o $$target; \
	  fi; \
	done)
	$(CXX) $(CXXFLAGS) -shared -Wl,-soname,libosl.so.1 -o $@ $(patsubst %,.objs/%,$(subst /,-,$^))
	ln -sf $@ libosl.so.1
	ln -sf $@ libosl.so

make-directories:
	find ../lib -type d | sed "s/\.\.\/lib\///" | xargs mkdir -p

=== sample/Makefile ===
OSL_HOME = ..
-include makefile.local
-include $(OSL_HOME)/makefile.local
include $(OSL_HOME)/makefile.conf

# type make RELEASE=yes to build optimized programs
# type make DEBUG=yes to build programs for debugging

LDFLAGS +=  -L$(OSL_LIB_DIR)
LOADLIBES += -lm -lboost_thread$(BOOST_POSTFIX_MT) -lboost_program_options$(BOOST_POSTFIX)

ifndef RELEASE
CXXOPTFLAGS ?= -O -DDEBUG
else
CXXOPTFLAGS = $(RELEASE_CXX_OPTFLAGS) -DNDEBUG
endif

ifneq ($(CXX),icc)
## gcc
ifdef RELEASE
WARNING_FLAGS += -Werror $(WARN_INLINE)
else
OTHERFLAGS = $(DEBUGFLAGS)
endif
OTHERFLAGS += -pipe $(CPUOPTION)
ifndef PROF
CXXOPTFLAGS += -fomit-frame-pointer
endif
endif

CXXFLAGS =  -DOSL_HOME=\"$(shell dirname `pwd`)\" $(PROF) $(WARNING_FLAGS) $(OTHERFLAGS) $(CXXOPTFLAGS) \
	$(GCH_INCLUDES) $(INCLUDES) $(ADDITIONALFLAGS)

PERFORMANCE_SRCS = isCheckPerf.cc \
  pin_perf.cc uniqueStorePerf.cc \
  progress_perf.cc rating-perf.cc see-perf.cc simpleMovePerf.cc
# commented out because their compilation take very long time: checkMovePerf.cc  fixedDepthSearchPerf.cc
EVAL_SRCS = show-state.cc show-progresseval.cc show-testeval.cc 
PPAIR_SRCS = pairdiff.cc pairedit.cc pairstat.cc 
DEBUG_SRCS = printPdp.cc printPosition.cc printMove.cc printPiece.cc \
	printPtypeO.cc printNcores.cc hash-dump.cc
OPENING_SRCS = convert.cc showOpening.cc opening-validator.cc openingStatistics.cc \
	compare-book.cc show-moves.cc
RATING_SRCS = ratingstat.cc probability.cc topn.cc
RECORD_SRCS = check-kisen.cc show-ipx.cc all-states.cc bad-moves.cc \
              show-ki2.cc show-ipx-result.cc csa-to-kisen.cc kisen-to-csa.cc \
	      count-win-loss.cc win-rate-openingbook-weight-level.cc \
              all-states2.cc find-states.cc check-ki2.cc \
	      kakinoki-to-csa.cc csa-to-kifu.cc 
MISC_SRCS = showCores.cc showMemory.cc

BOARD_SRCS = random_play.cc legal_moves.cc \
	showRecord.cc show_repetition.cc show-effect.cc \
	progress/show-state.cc \
	$(patsubst %.cc,eval/%.cc,$(EVAL_SRCS)) \
	$(patsubst %.cc,eval/ppair/%.cc,$(PPAIR_SRCS)) \
	$(patsubst %.cc,record/%.cc,$(RECORD_SRCS)) \
	$(patsubst %.cc,misc/%.cc,$(MISC_SRCS))
SEARCH_SRCS = 	dfpnstat.cc fixed-checkmate.cc sort.cc \
	fixed-checkmate2.cc find-losing-moves.cc \
	quiescence/quiescencestat.cc quiescence/range-vs-nodes.cc \
	quiescence/quiescence2stat.cc \
	$(patsubst %.cc,debug/%.cc,$(DEBUG_SRCS)) \
	$(patsubst %.cc,opening/%.cc,$(OPENING_SRCS)) \
	$(patsubst %.cc,rating/%.cc,$(RATING_SRCS)) \
	annotate/annotate.cc \
	$(patsubst %.cc,performance/%.cc,$(PERFORMANCE_SRCS)) \
	record/checkmate-kisen.cc

BOARD_PROGRAMS = $(BOARD_SRCS:.cc=) 
SEARCH_PROGRAMS = $(SEARCH_SRCS:.cc=) 
PROGRAMS = $(BOARD_PROGRAMS) $(SEARCH_PROGRAMS)
CC = $(CXX)

all: $(BOARD_PROGRAMS) $(SEARCH_PROGRAMS)

# CC, LDFLAGS, LOADLIBES を定義しておくと
# %.o から % を勝手に作ってくれるので
# 特別なもの以外は書く必要がない
opening/convert: opening/convert.o opening/openingBookConverter.o
opening/openingBookConverter.o: opening/openingBookConverter.cc opening/openingBookConverter.h

$(SEARCH_PROGRAMS): $(FILE_OSL_ALL)
$(BOARD_PROGRAMS): $(FILE_OSL_BOARD)

clean: 
	rm -f core *.o */*.o $(PROGRAMS) nohup.out *~
distclean: clean 
	rm -f *~

-include $(patsubst %.cc,.deps/%.cc.d,$(BOARD_SRCS))
-include $(patsubst %.cc,.deps/%.cc.d,$(SEARCH_SRCS))

=== test/Makefile ===
OSL_HOME = ..
-include makefile.local
-include $(OSL_HOME)/makefile.local
-include $(OSL_HOME)/makefile.conf

LOADLIBES += -lcppunit -lboost_thread$(BOOST_POSTFIX_MT) $(LDLIBS)

CXXOPTFLAGS ?= -O -DDEBUG
OTHERFLAGS = -pipe $(DEBUGFLAGS) $(CPUOPTION)
CXXFLAGS = $(CXXOPTFLAGS) $(OTHERFLAGS) \
	$(WARNING_FLAGS) $(GCH_INCLUDES) $(INCLUDES)

PROGRAMS = testBoard testSearch testAll testOpening

ifdef USE_NTESUKI
 TEST_OBJS += $(Q_NTESUKI_OBJS)
 PROGRAMS += testNtesuki
endif

all : 
	$(MAKE) update-lib
	$(MAKE) test-target
test-target: $(PROGRAMS)
update-lib:
	cd $(OSL_HOME)/lib; $(MAKE)

BOARD_OBJS = board.t.o ptype.t.o player.t.o piece.t.o move.t.o direction.t.o \
	centering3x3.t.o centering5x3.t.o ptypeList.t.o \
	pathEncoding.t.o pieceStand.t.o pieceStandIO.t.o repetitionCounter.t.o \
	container/pieceMask.t.o container/bitXmask.t.o \
	container/moveStack.t.o \
	container/moveLogProbVector.t.o container/ptypeOPositionVector.t.o \
	container/boardMask.t.o container/tripleInt.t.o container/quadInt.t.o \
	misc/fixedCapacityVector.t.o misc/carray.t.o misc/carray2d.t.o \
	misc/mask.t.o misc/nonBlockDelete.t.o misc/reorder.t.o \
	misc/math.t.o misc/base64.t.o misc/fastCopier.t.o \
	misc/bitOp.t.o \
	stl/vector.t.o \
	apply_move/doUndoMoveLock.t.o \
	eval/pieceEval.t.o eval/progressEval.t.o eval/see.t.o \
	eval/minorPieceBonus.t.o \
	eval/ppair/piecePairIndex.t.o eval/ppair/piecePairRawEval.t.o \
	eval/ppair/piecePairPieceEval.t.o \
	eval/endgame/attackKing.t.o eval/endgame/defenseKing.t.o \
	eval/endgame/attackDefense.t.o \
	eval/ml/piecePair.t.o \
	eval/ml/openMidEndingEval.t.o \
	state/simpleState.t.o \
	state/pawnMaskState.t.o \
	state/numEffectState.t.o effect/moveSignature.t.o \
	effect/liberty8.t.o \
	stat/twoDimensionalStatistics.t.o \
	hash/boardKey.t.o hash/hashKey.t.o hash/hashRandom.t.o \
	progress/ptypeProgress.t.o progress/effect5x3.t.o \
	progress/effect5x3d.t.o progress/ml/newProgress.t.o \
	$(patsubst %.o,record/%.o,$(RECORD_OBJS)) \
	$(patsubst %.o,move_generator/%.o,$(MOVE_GENERATOR_OBJS)) \
	$(patsubst %.o,move_classifier/%.o,$(MOVE_CLASSIFIER_OBJS)) \
	$(patsubst %.o,move_order/%.o,$(MOVE_ORDER_OBJS)) \
	$(patsubst %.o,effect_util/%.o,$(EFFECT_UTIL_OBJS)) \
	$(patsubst %.o,threatmate/%.o,$(THREATMATE_OBJS)) \
	$(patsubst %.o,mobility/%.o,$(MOBILITY_OBJS)) \
	enter_king/enterKing.t.o 
# 	move_action/safeFilter.t.o move_action/shouldPromoteFilter.t.o \
RECORD_OBJS = csa.t.o record.t.o kisen.t.o psn.t.o kanjiPrint.t.o usi.t.o \
	kanjiMove.t.o ki2.t.o compactBoard.t.o miniBoard.t.o miniBoardChar50.t.o
MOVE_GENERATOR_OBJS = allMoves.t.o capture_.t.o \
  escapeMoves.t.o promote_.t.o kingWalk.t.o dropAroundKing8.t.o \
  openKingRoad.t.o captureEffectToAroundKing8.t.o safeDropMajorPiece.t.o \
	addEffect8.t.o attackToPinned.t.o addEffect8Defense.t.o \
	addEffectWithEffect.t.o legalMoves.t.o
# addEffect_.t.o 
MOVE_CLASSIFIER_OBJS = check_.t.o kingOpenMove.t.o safeMove.t.o \
	pawnDropCheckmate.t.o attackDefenceAroundKing.t.o \
	blockLongEffect.t.o trapRook.t.o 
MOVE_ORDER_OBJS = promotion.t.o cheapPtype.t.o captureSort.t.o \
	captureEstimation.t.o
EFFECT_UTIL_OBJS = pin.t.o additionalEffect.t.o unblockableCheck.t.o \
	effectUtil.t.o sendOffPosition.t.o neighboring8Direct.t.o \
	virtualPin.t.o
MOBILITY_OBJS = countMobility.t.o rookMobility.t.o bishopMobility.t.o \
	lanceMobility.t.o mobilityTable.t.o
THREATMATE_OBJS = kfendPredictor.t.o richPredictor.t.o treePredictor.t.o mlPredictor.t.o
SEARCH_OBJS = problems.o simpleHashRecord.t.o fixedEval.t.o \
	searchRecorder.t.o simpleHashTable.t.o \
	moveGenerator.t.o alphaBeta2.t.o \
	breakThreatmate.t.o hashRejections.t.o \
	moveStackRejections.t.o \
	threatmateState.t.o dualThreatmateState.t.o lRUMoves.t.o \
	quiescenceSearch.t.o quiescenceRecord.t.o quiescenceGenerator.t.o \
	dominanceCheck.t.o \
	bigramKillerMove.t.o  sacrificeCheck.t.o \
	shouldPromoteCut.t.o 
CHECKMATE_OBJS = proofDisproof.t.o \
	proofPieces.t.o \
	pawnCheckmateMoves.t.o \
	dfpn.t.o dualDfpn.t.o oracleProver.t.o \
	fixedDepthSearcher.t.o checkmateIfCapture.t.o \
	immediateCheckmate.t.o proofNumberTable.t.o \
	oracleAdjust.t.o 
NTESUKI_OBJS = ntesukiResult.t.o ntesukiRecord.t.o ntesukiTable.t.o rzone.t.o \
	ntesukiMoveGenerator.t.o ntesukiSearcher.t.o ntesukiSimulationSearcher.t.o
GAME_PLAYING_OBJS = recordTracer.t.o bookPlayer.t.o csaClient.t.o \
	gnuShogiClient.t.o historyToTable.t.o searchPlayer.t.o \
	gameState.t.o alphaBetaPlayer.t.o alphaBetaOpenMidEndingEvalPlayer.t.o \
	weightTracer.t.o
RATING_OBJS = standardFeatureSet.t.o ratedMoveVector.t.o feature/patternLong.t.o \
	feature/threatmate.t.o
OPENING_OBJS = openingBook.t.o

MISC_OBJS = 

# qualified objects
Q_SEARCH_OBJS = $(patsubst %.o,search/%.o,$(SEARCH_OBJS)) \
	$(patsubst %.o,checkmate/%.o,$(CHECKMATE_OBJS)) \
	$(patsubst %.o,game_playing/%.o,$(GAME_PLAYING_OBJS)) 
Q_NTESUKI_OBJS = $(patsubst %.o,ntesuki/%.o,$(NTESUKI_OBJS))
Q_RATING_OBJS = $(patsubst %.o,rating/%.o,$(RATING_OBJS))
Q_OPENING_OBJS = $(patsubst %.o,record/opening/%.o,$(OPENING_OBJS))
TEST_OBJS = $(BOARD_OBJS) $(Q_SEARCH_OBJS) $(Q_OPENING_OBJS) \
 $(MISC_OBJS) $(Q_RATING_OBJS)

OBJS = testAll.o $(TEST_OBJS)
SRCS = $(patsubst %.o,%.cc,$(OBJS))

search/alphaBeta2.t: search/alphaBeta2.t.o testOne.o search/problems.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(CXXFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LDFLAGS) $(LOADLIBES) 
%.t: %.t.o testOne.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(CXXFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LDFLAGS) $(LOADLIBES) 
# make binary forcibly adding -O0 flags so that gdb can well trace the program
%.t.gdb: %.t.cc %.t.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(CXXFLAGS) -o $(OUTPUTPREFIX)$@ -O0 testOne.cc $< $(FILE_OSL_ALL) $(LDFLAGS) $(LOADLIBES) 

-include $(patsubst %.cc,.deps/%.cc.d,$(SRCS))

testAll: $(OBJS) $(FILE_OSL_ALL)
	mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) 
testLong: testOne.o $(TEST_OBJS) $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) 

testBoard: $(BOARD_OBJS) testAll.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^  $(LOADLIBES) 
testSearch: $(Q_SEARCH_OBJS) testAll.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) 
testNtesuki: $(Q_NTESUKI_OBJS) testAll.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) 
testRating: $(Q_RATING_OBJS) testAll.o $(FILE_OSL_ALL)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) 
testOpening: $(Q_OPENING_OBJS) testAll.o $(FILE_OSL_BOARD)
	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^  $(LOADLIBES) 

light-clean:
	-rm -rf .deps 
clean: light-clean
	-rm -f core *.o $(OBJS) $(PROGRAMS) nohup.out checkmate.log
distclean: clean 
	rm -f *~

=== debian/changelog ===
libosl (0.3.0-1) unstable; urgency=low

  * New upstream release (OSL r4174).
  * Added debian/source/format file.
  * debian/control: 
    - Bumped up Standards-Version: 3.8.4.
    - Build with Boost 1.42.
  * debian/makefile.local.*: disabled USE_TBB
  * debian/makefile.local.amd64: added -march=k8.
    (Closes: #582923)

 -- Daigo Moriwaki <daigo@debian.org>  Tue, 25 May 2010 21:56:08 +0900

libosl (0.2.0-2) unstable; urgency=low

  * Added a g++ option, -march=pentium4, for the i386 architecture due to the
    package requires SSE2. (Closes: #568595)

 -- Daigo Moriwaki <daigo@debian.org>  Sat, 06 Feb 2010 11:15:54 +0900

libosl (0.2.0-1) unstable; urgency=low

  * Initial release. (Closes: #564231)

 -- Daigo Moriwaki <daigo@debian.org>  Sat, 09 Jan 2010 00:02:46 +0900

=== debian/control ===
Source: libosl
Section: libs
Priority: optional
Maintainer: Daigo Moriwaki <daigo@debian.org>
Build-Depends: cdbs, debhelper (>= 7), libcppunit-dev (>= 1.10.2-5), libboost1.42-all-dev
Standards-Version: 3.8.4
Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
Vcs-Browser: http://git.debian.org/?p=collab-maint/libosl.git;a=summary
Vcs-Git: git://git.debian.org/git/collab-maint/libosl.git

Package: libosl1
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libosl-doc
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess. 
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc. 
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc. 
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc. 
 .
 OSL works only on Pentium4 or later compatible CPUs due to using the SSE2
 instruction set.

Package: libosl-dev
Section: libdevel
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, libosl1 (= ${binary:Version})
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess. 
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc. 
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc. 
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc. 
 .
 This package contains header files and static libraries for developers.

Package: libosl1-dbg
Priority: extra
Section: debug
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, libosl1 (= ${binary:Version})
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess. 
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc. 
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc. 
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc. 
 .
 This package is provided primarily to provide a backtrace with names in a
 debugger and makes it easier to interpret core dumps. Most users will not
 need this package.

Package: libosl-doc
Section: doc
Architecture: all
Suggests: libosl1
Depends: ${misc:Depends}
Description: library for Shogi playing programs
 OpenShogiLib (OSL) provides following features of Shogi playing programs,
 especially for Shogi programming study. Shogi is a Japanese two-player board
 game like Chess. 
 1. Board: reading/writing records, generating legal moves etc.
 2. Evaluation function: piece values and a lot of features
 3. Hash table: hashing boards etc. 
 4. Checkmate search: concurrent df-pn+ etc.
 5. Search framework: full-depth search, realization probability etc. 
 6. Move category: mate, illegal moves etc.
 7. Opening book
 8. Gaming: search time control etc. 
 .
 This package contains documents that Doxygen generates from OSL source files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk

DEB_MAKE_CLEAN_TARGET   = clean
DEB_MAKE_BUILD_TARGET   = all
DEB_MAKE_INSTALL_TARGET = 
DEB_MAKE_CHECK_TARGET   =

so_ver=1

DEB_DBG_PACKAGE_libosl$(so_ver) = libosl$(so_ver)-dbg

DEB_INSTALL_DIRS_libosl$(so_ver) += usr/lib

DEB_INSTALL_DIRS_libosl-dev += usr/lib usr/include usr/share/libosl-dev

DEB_INSTALL_DIRS_libosl-doc += usr/share/doc/libosl-doc
DEB_INSTALL_DOCS_libosl-doc += doc/html

pre-build::
	cp $(CURDIR)/debian/makefile.local.$(DEB_HOST_ARCH_CPU) $(CURDIR)/makefile.local

build/libosl$(so_ver)::
	$(MAKE) -C release-so make-directories
	$(MAKE) -C release-so PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" libosl.so.$(so_ver).0

binary-install/libosl$(so_ver)::
	dh_install -p$(cdbs_curpkg) --sourcedir=release-so libosl.so.* usr/lib

build/libosl-dev::
	$(MAKE) -C release make-directories
	$(MAKE) -C release PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" all

binary-install/libosl-dev::
	dh_install -p$(cdbs_curpkg) --sourcedir=release lib*.a usr/lib
	dh_install -p$(cdbs_curpkg) --sourcedir=release-so libosl.so usr/lib
	dh_install -p$(cdbs_curpkg) --sourcedir=include -X.svn osl usr/include
	dh_install -p$(cdbs_curpkg) --sourcedir=$(CURDIR) makefile.conf makefile.local \
	  usr/share/$(cdbs_curpkg)

clean::
	$(MAKE) -C release clean
	$(MAKE) -C release-so clean
	-rm release-so/libosl.so*
	-rm -f $(CURDIR)/makefile.local

## libosl 0.4.0

=== lib/Makefile ===
--- 
+++ 
@@ -51,6 +51,7 @@
 	$(BASIC_OBJS)
 LIB_SEARCH_OBJS = \
 	$(patsubst %.o,rating/%.o,$(RATING_OBJS)) \
+	$(patsubst %.o,move_probability/%.o,$(MOVE_PROBABILITY_OBJS)) \
 	$(patsubst %.o,search/%.o,$(SEARCH_OBJS)) \
 	$(patsubst %.o,checkmate/%.o,$(CHECKMATE_OBJS)) \
 	$(patsubst %.o,game_playing/%.o,$(GAME_PLAYING_OBJS)) \
@@ -72,8 +73,8 @@
 	mobility/mobilityTable.o \
 	container/bitXmask.o container/pieceMask.o container/moveStack.o \
 	container/moveVector.o container/moveLogProbVector.o \
-	container/pieceVector.o container/ptypeOPositionVector.o \
-	container/nearMask.o container/pieceValues.o container/position8.o \
+	container/pieceVector.o container/ptypeOSquareVector.o \
+	container/nearMask.o container/pieceValues.o container/square8.o \
 	container/boardMask.o container/tripleInt.o \
 	eval/pieceEval.o eval/progressEval.o eval/see.o \
 	eval/endgame/attackKing.o eval/endgame/defenseKing.o \
@@ -92,17 +93,17 @@
 	progress/ptypeProgress.o progress/effect5x3.o \
 	progress/effect5x3d.o progress/effect5x3Table.o \
 	progress/ml/newProgress.o \
-	ptypeList.o ptype.o position.o player.o piece.o \
+	ptypeList.o ptype.o square.o player.o piece.o \
 	offset.o offset32.o pieceTable.o boardTable.o ptypeTable.o \
-	move.o direction.o  positionCompressor.o sennichite.o \
+	move.o direction.o  squareCompressor.o sennichite.o \
 	centering3x3.o centering5x3.o \
 	moveLogProb.o pieceStand.o pieceStandIO.o pathEncoding.o \
 	tables.o repetitionCounter.o oslConfig.o \
 	misc/mask.o misc/trace.o misc/milliSeconds.o misc/random.o misc/perfmon.o \
 	misc/nonBlockDelete.o misc/align16New.o \
-	misc/ncores.o misc/base64.o misc/ctime.o misc/fastCopier.o\
+	misc/ncores.o misc/base64.o misc/ctime.o \
 	misc/log/htmlPerformanceLog.o misc/log/textPerformanceLog.o \
-	misc/sjis2euc.o misc/iconvConvert.o \
+	misc/sjis2euc.o misc/iconvConvert.o misc/binaryIO.o \
 	enter_king/enterKing.o
 # LIB_SEARCH_OBJS の方が相応しいがtables.ccの関係で LIB_BOARD_OBJS に
 # 入れる必要があるもの
@@ -114,10 +115,11 @@
 	pieceOnBoard.o capture_.o promote_.o legalMoves.o \
 	addEffect8.o addEffect8Table.o attackToPinned.o additionalLance.o \
 	addEffectWithEffect.o 
-# addEffect_.o addEffectTable.o 
 MOVE_CLASSIFIER_OBJS = check_.o safeMove.o kingOpenMove.o \
-	blockLongEffect.o trapRook.o canAttackInNMoves.o 
-RECORD_OBJS = record.o csa.o csaString.o kisen.o opening/openingBook.o psn.o \
+	blockLongEffect.o trapRook.o canAttackInNMoves.o classifier.o
+MOVE_PROBABILITY_OBJS = stateInfo.o feature.o featureSet.o moveInfo.o
+RECORD_OBJS = record.o csa.o csaString.o kisen.o \
+	opening/openingBook.o opening/bookInMemory.o psn.o \
 	csaRecord.o compactBoard.o miniBoard.o kanjiPrint.o usi.o kanjiMove.o \
 	ki2.o checkDuplicate.o kakinoki.o miniBoardChar50.o myshogi.o
 SEARCH_OBJS = killerMoveTable.o bigramKillerMove.o quiescenceSearch2.o \
@@ -131,7 +133,7 @@
 	alphaBeta3.o hashRejections.o moveWithComment.o \
 	moveStackRejections.o \
 	analyzer/recordSet_.o analyzer/categoryMoveVector.o \
-	quiescenceLog.o recordStack.o \
+	quiescenceLog.o \
 	analyzer/dotWriter.o analyzer/logWriter.o 
 CHECKMATE_OBJS = pieceCost.o proofTreeDepthDfpn.o \
 	fixedDepthSearcher.o \
@@ -144,13 +146,13 @@
 	ntesukiMoveGenerator.o
 RATING_OBJS = feature.o group.o featureSet.o \
 	ratedMove.o ratedMoveVector.o ratingEnv.o \
-	feature/pattern.o feature/capture.o feature/checkmate.o feature/position.o \
+	feature/pattern.o feature/capture.o feature/checkmate.o feature/square.o \
 	feature/countEffect2.o feature/bigramAttack.o feature/king8.o \
-	group/bigramGroup.o group/captureGroup.o group/positionGroup.o \
+	group/bigramGroup.o group/captureGroup.o group/squareGroup.o \
 	group/patternGroup.o group/escape.o group/king8Group.o bradleyTerry.o 
 STAT_OBJS = twoDimensionalStatistics.o histogram.o ratio.o 
 EFFECT_UTIL_OBJS = additionalEffect.o effectUtil.o shadowEffect.o \
-	neighboring8Direct.o neighboring25Direct.o sendOffPosition.o \
+	neighboring8Direct.o neighboring25Direct.o sendOffSquare.o \
 	neighboring8Effect.o pin.o virtualPin.o
 GAME_PLAYING_OBJS = gameState.o computerPlayer.o csaLogger.o \
 	gameManager.o gnuShogiClient.o csaClient.o cuiClient.o \

=== debian/changelog ===
libosl (0.4.0-1ubuntu1) oneiric; urgency=low

  * debian/rules: disable -Werror for -Wunused-but-set-variable
  * debian/patches/link-boost.patch: link shared lib with boost (LP: #770752)

 -- Julian Taylor <jtaylor.debian@googlemail.com>  Mon, 29 Aug 2011 17:30:59 +0200

libosl (0.4.0-1) unstable; urgency=low

  * New upstream release (OSL r4353).
    (Closes: #615676, #625371)
  * debian/control: 
    - Bumped up Standards-Version: 3.9.2.
    - Build with Boost 1.46.
  * debian/rules:
    - Support parallel build.
  * debian/makefile.local.*
    - Followed a change in Boost.

 -- Daigo Moriwaki <daigo@debian.org>  Sat, 11 Jun 2011 14:43:47 +0900

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: libosl
 Section: libs
 Priority: optional
-Maintainer: Daigo Moriwaki <daigo@debian.org>
-Build-Depends: cdbs, debhelper (>= 7), libcppunit-dev (>= 1.10.2-5), libboost1.42-all-dev
-Standards-Version: 3.8.4
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Daigo Moriwaki <daigo@debian.org>
+Build-Depends: cdbs, debhelper (>= 7), libcppunit-dev (>= 1.10.2-5), libboost1.46-all-dev
+Standards-Version: 3.9.2
 Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php
 Vcs-Browser: http://git.debian.org/?p=collab-maint/libosl.git;a=summary
 Vcs-Git: git://git.debian.org/git/collab-maint/libosl.git

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 DEB_MAKE_BUILD_TARGET   = all
 DEB_MAKE_INSTALL_TARGET = 
 DEB_MAKE_CHECK_TARGET   =
+
+DEB_MAKE_PARALLEL ?= $(and $(DEB_BUILD_PARALLEL),$(DEB_PARALLEL_JOBS),-j$(DEB_PARALLEL_JOBS))
 
 so_ver=1
 
@@ -18,19 +20,22 @@
 DEB_INSTALL_DIRS_libosl-doc += usr/share/doc/libosl-doc
 DEB_INSTALL_DOCS_libosl-doc += doc/html
 
+
 pre-build::
 	cp $(CURDIR)/debian/makefile.local.$(DEB_HOST_ARCH_CPU) $(CURDIR)/makefile.local
 
 build/libosl$(so_ver)::
 	$(MAKE) -C release-so make-directories
-	$(MAKE) -C release-so PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" libosl.so.$(so_ver).0
+# unused-but-set-variable disable until 633473 is fixed
+	$(MAKE) -C release-so WARN_UNUSED="-Wno-error=unused-but-set-variable -Wno-unused-parameter" PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" $(DEB_MAKE_PARALLEL) libosl.so.$(so_ver).0
 
 binary-install/libosl$(so_ver)::
 	dh_install -p$(cdbs_curpkg) --sourcedir=release-so libosl.so.* usr/lib
 
 build/libosl-dev::
 	$(MAKE) -C release make-directories
-	$(MAKE) -C release PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" all
+# unused-but-set-variable disable until 633473 is fixed
+	$(MAKE) -C release WARN_UNUSED="-Wno-error=unused-but-set-variable -Wno-unused-parameter" PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" $(DEB_MAKE_PARALLEL) all
 
 binary-install/libosl-dev::
 	dh_install -p$(cdbs_curpkg) --sourcedir=release lib*.a usr/lib

## libosl 0.4.2

=== CMakeLists.txt ===
project (osl CXX)
cmake_minimum_required (VERSION 2.8)
set (CMAKE_VERBOSE_MAKEFILE on)

ENABLE_TESTING()

if (UNIX)
  set (CMAKE_CXX_FLAGS "-Wall")
  set (CMAKE_CXX_FLAGS_DEBUG "-O0 -g -DDEBUG")
  set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG")
  add_definitions(-march=native -DBOOST_FILESYSTEM_VERSION=2) 
endif()

if(MINGW)
  set (CMAKE_CXX_FLAGS "-Wall -mthreads")
  set (CMAKE_CXX_FLAGS_DEBUG "-O0 -g -DDEBUG")
  set (CMAKE_CXX_FLAGS_RELEASE "-O3 -DNDEBUG -march=pentium4 -funroll-loops -funswitch-loops -fpeel-loops --param large-function-growth=48000 --param inline-unit-growth=8000 --param max-inline-insns-single=8000 -fomit-frame-pointer")
  add_definitions(-DOSL_SMP=1 -DOSL_DFPN_SMP_SEARCH -DMORE_CHECKMATE_IF_CAPTURE_MAJOR -DBOOST_FILESYSTEM_VERSION=2 -DBOOST_THREAD_USE_LIB=1 -DUSE_BOOST_POOL_ALLOCATOR=1 -D_WIN32_WINNT=0x0500)
  set (BOOST_ROOT "$ENV{HOME}/local/src/boost_1_46_1/")
endif(MINGW)

add_definitions(-DOSL_HOME="${CMAKE_CURRENT_SOURCE_DIR}" -DUSE_TCMALLOC=0 -D_REENTRANT)

include_directories ("${PROJECT_SOURCE_DIR}/include")

## Pthreads
#find_package (Threads)
#if (Threads_FOUND)
#  message (STATUS "Threads: ${CMAKE_THREAD_LIBS_INIT}")
#else()
#  message (FATAL_ERROR "Threads not found")
#endif()

## Boost thing
#set (BOOST_ROOT "$ENV{HOME}/local/boost_1_36_0_binaries/")
set (Boost_USE_STATIC_LIBS ON)
set (Boost_USE_MULTITHREADED ON)
find_package (Boost 1.46.1)
if (Boost_FOUND)
  include_directories (${Boost_INCLUDE_DIRS})
  message (STATUS ${Boost_INCLUDE_DIRS})
else()
  message (FATAL_ERROR "Boost installation not found")
endif()

## Program SampleCounter
file(GLOB_RECURSE OSL_HEADERS  include/*.h include/*.tcc)
file(GLOB_RECURSE OSL_SRCS     lib/*.cc)
file(GLOB_RECURSE EXCLUDE_SRCS lib/third_party/*.cc lib/ntesuki/*.cc)
list(REMOVE_ITEM OSL_SRCS ${EXCLUDE_SRCS})
#message (STATUS "Headers: ${OSL_HEADERS}")
#message (STATUS "Sources: ${OSL_SRCS}")
#set (SampleAleriUDF_ALL_SRCS ${SampleAleriUDF_HEADERS} ${SampleAleriUDF_SRCS})
add_library (osl-static STATIC ${OSL_SRCS})
SET_TARGET_PROPERTIES(osl-static PROPERTIES OUTPUT_NAME "osl")
SET_TARGET_PROPERTIES(osl-static PROPERTIES PREFIX "lib")
if (UNIX)
  add_library (osl SHARED ${OSL_SRCS})
  target_link_libraries (osl ${CMAKE_THREAD_LIBS_INIT})
endif()

=== release-so/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	    ln -s ../$$o $$target; \
 	  fi; \
 	done)
-	$(CXX) $(CXXFLAGS) -shared -Wl,-soname,libosl.so.1 -o $@ $(patsubst %,.objs/%,$(subst /,-,$^))
+	$(CXX) $(CXXFLAGS) -shared -Wl,-soname,libosl.so.1 -o $@ $(patsubst %,.objs/%,$(subst /,-,$^)) -lboost_program_options$(BOOST_POSTFIX) -lboost_filesystem$(BOOST_POSTFIX) -lboost_serialization$(BOOST_POSTFIX) -lboost_iostreams$(BOOST_POSTFIX) -lboost_thread$(BOOST_POSTFIX_MT) -lboost_system$(BOOST_POSTFIX)
 	ln -sf $@ libosl.so.1
 	ln -sf $@ libosl.so

=== sample/Makefile ===
--- 
+++ 
@@ -35,31 +35,33 @@
   pin_perf.cc uniqueStorePerf.cc \
   progress_perf.cc rating-perf.cc see-perf.cc simpleMovePerf.cc
 # commented out because their compilation take very long time: checkMovePerf.cc  fixedDepthSearchPerf.cc
-EVAL_SRCS = show-state.cc show-progresseval.cc show-testeval.cc 
+EVAL_SRCS = show-state.cc show-progresseval.cc show-eval.cc 
 PPAIR_SRCS = pairdiff.cc pairedit.cc pairstat.cc 
 DEBUG_SRCS = printPdp.cc printPosition.cc printMove.cc printPiece.cc \
 	printPtypeO.cc printNcores.cc hash-dump.cc
 OPENING_SRCS = convert.cc showOpening.cc opening-validator.cc openingStatistics.cc \
 	compare-book.cc show-moves.cc
 RATING_SRCS = ratingstat.cc probability.cc topn.cc
+CHECKMATE_SRCS = dfpnstat.cc fixed-checkmate.cc fixed-checkmate2.cc make-problems.cc
 RECORD_SRCS = check-kisen.cc show-ipx.cc all-states.cc bad-moves.cc \
               show-ki2.cc show-ipx-result.cc csa-to-kisen.cc kisen-to-csa.cc \
 	      count-win-loss.cc win-rate-openingbook-weight-level.cc \
-              all-states2.cc find-states.cc check-ki2.cc \
-	      kakinoki-to-csa.cc csa-to-kifu.cc 
-MISC_SRCS = showCores.cc showMemory.cc
+              all-states2.cc find-states.cc check-ki2.cc showRecord.cc \
+	      kakinoki-to-csa.cc csa-to-kifu.cc kifu-to-myshogi.cc showRecord.cc
+MISC_SRCS = showCores.cc showMemory.cc convert.cc
 
 BOARD_SRCS = random_play.cc legal_moves.cc \
-	showRecord.cc show_repetition.cc show-effect.cc \
+	show_repetition.cc show-effect.cc \
 	progress/show-state.cc \
 	$(patsubst %.cc,eval/%.cc,$(EVAL_SRCS)) \
 	$(patsubst %.cc,eval/ppair/%.cc,$(PPAIR_SRCS)) \
 	$(patsubst %.cc,record/%.cc,$(RECORD_SRCS)) \
 	$(patsubst %.cc,misc/%.cc,$(MISC_SRCS))
-SEARCH_SRCS = 	dfpnstat.cc fixed-checkmate.cc sort.cc \
-	fixed-checkmate2.cc find-losing-moves.cc \
+SEARCH_SRCS = 	sort.cc \
+	find-losing-moves.cc find-uplevel-king.cc \
 	quiescence/quiescencestat.cc quiescence/range-vs-nodes.cc \
 	quiescence/quiescence2stat.cc \
+	$(patsubst %.cc,checkmate/%.cc,$(CHECKMATE_SRCS)) \
 	$(patsubst %.cc,debug/%.cc,$(DEBUG_SRCS)) \
 	$(patsubst %.cc,opening/%.cc,$(OPENING_SRCS)) \
 	$(patsubst %.cc,rating/%.cc,$(RATING_SRCS)) \
@@ -80,6 +82,10 @@
 opening/convert: opening/convert.o opening/openingBookConverter.o
 opening/openingBookConverter.o: opening/openingBookConverter.cc opening/openingBookConverter.h
 
+checkmate/dfpnstatone-static: checkmate/dfpnstatone.cc checkmate/dfpnstat.cc
+	$(CXX) -o $@ $(CXXFLAGS) $(OSL_HOME_FLAGS) $(LDFLAGS) $< $(LDLIBS) $(FILE_TCMALLOC)  $(LOADLIBES)
+
+
 $(SEARCH_PROGRAMS): $(FILE_OSL_ALL)
 $(BOARD_PROGRAMS): $(FILE_OSL_BOARD)

=== test/Makefile ===
--- 
+++ 
@@ -29,20 +29,20 @@
 	pathEncoding.t.o pieceStand.t.o pieceStandIO.t.o repetitionCounter.t.o \
 	container/pieceMask.t.o container/bitXmask.t.o \
 	container/moveStack.t.o \
-	container/moveLogProbVector.t.o container/ptypeOPositionVector.t.o \
+	container/moveLogProbVector.t.o container/ptypeOSquareVector.t.o \
 	container/boardMask.t.o container/tripleInt.t.o container/quadInt.t.o \
 	misc/fixedCapacityVector.t.o misc/carray.t.o misc/carray2d.t.o \
 	misc/mask.t.o misc/nonBlockDelete.t.o misc/reorder.t.o \
 	misc/math.t.o misc/base64.t.o misc/fastCopier.t.o \
 	misc/bitOp.t.o \
-	stl/vector.t.o \
+	stl/vector.t.o stl/hash_map.t.o stl/hash_set.t.o \
 	apply_move/doUndoMoveLock.t.o \
 	eval/pieceEval.t.o eval/progressEval.t.o eval/see.t.o \
 	eval/minorPieceBonus.t.o \
 	eval/ppair/piecePairIndex.t.o eval/ppair/piecePairRawEval.t.o \
 	eval/ppair/piecePairPieceEval.t.o \
 	eval/endgame/attackKing.t.o eval/endgame/defenseKing.t.o \
-	eval/endgame/attackDefense.t.o \
+	eval/endgame/attackDefense.t.o eval/endgame/kingPieceTable.t.o \
 	eval/ml/piecePair.t.o \
 	eval/ml/openMidEndingEval.t.o \
 	state/simpleState.t.o \
@@ -61,22 +61,21 @@
 	$(patsubst %.o,threatmate/%.o,$(THREATMATE_OBJS)) \
 	$(patsubst %.o,mobility/%.o,$(MOBILITY_OBJS)) \
 	enter_king/enterKing.t.o 
-# 	move_action/safeFilter.t.o move_action/shouldPromoteFilter.t.o \
 RECORD_OBJS = csa.t.o record.t.o kisen.t.o psn.t.o kanjiPrint.t.o usi.t.o \
 	kanjiMove.t.o ki2.t.o compactBoard.t.o miniBoard.t.o miniBoardChar50.t.o
 MOVE_GENERATOR_OBJS = allMoves.t.o capture_.t.o \
   escapeMoves.t.o promote_.t.o kingWalk.t.o dropAroundKing8.t.o \
-  openKingRoad.t.o captureEffectToAroundKing8.t.o safeDropMajorPiece.t.o \
-	addEffect8.t.o attackToPinned.t.o addEffect8Defense.t.o \
+  openKingRoad.t.o safeDropMajorPiece.t.o \
+	addEffect8.t.o attackToPinned.t.o  \
 	addEffectWithEffect.t.o legalMoves.t.o
-# addEffect_.t.o 
+
 MOVE_CLASSIFIER_OBJS = check_.t.o kingOpenMove.t.o safeMove.t.o \
 	pawnDropCheckmate.t.o attackDefenceAroundKing.t.o \
 	blockLongEffect.t.o trapRook.t.o 
 MOVE_ORDER_OBJS = promotion.t.o cheapPtype.t.o captureSort.t.o \
 	captureEstimation.t.o
 EFFECT_UTIL_OBJS = pin.t.o additionalEffect.t.o unblockableCheck.t.o \
-	effectUtil.t.o sendOffPosition.t.o neighboring8Direct.t.o \
+	effectUtil.t.o sendOffSquare.t.o neighboring8Direct.t.o \
 	virtualPin.t.o
 MOBILITY_OBJS = countMobility.t.o rookMobility.t.o bishopMobility.t.o \
 	lanceMobility.t.o mobilityTable.t.o
@@ -93,13 +92,14 @@
 	shouldPromoteCut.t.o 
 CHECKMATE_OBJS = proofDisproof.t.o \
 	proofPieces.t.o \
-	pawnCheckmateMoves.t.o \
+	pawnCheckmateMoves.t.o king8Info.t.o \
 	dfpn.t.o dualDfpn.t.o oracleProver.t.o \
 	fixedDepthSearcher.t.o checkmateIfCapture.t.o \
 	immediateCheckmate.t.o proofNumberTable.t.o \
 	oracleAdjust.t.o 
 NTESUKI_OBJS = ntesukiResult.t.o ntesukiRecord.t.o ntesukiTable.t.o rzone.t.o \
-	ntesukiMoveGenerator.t.o ntesukiSearcher.t.o ntesukiSimulationSearcher.t.o
+	ntesukiMoveGenerator.t.o ntesukiSearcher.t.o ntesukiSimulationSearcher.t.o \
+	move_generator/addEffect8Defense.t.o move_generator/captureEffectToAroundKing8.t.o 
 GAME_PLAYING_OBJS = recordTracer.t.o bookPlayer.t.o csaClient.t.o \
 	gnuShogiClient.t.o historyToTable.t.o searchPlayer.t.o \
 	gameState.t.o alphaBetaPlayer.t.o alphaBetaOpenMidEndingEvalPlayer.t.o \
@@ -107,7 +107,8 @@
 RATING_OBJS = standardFeatureSet.t.o ratedMoveVector.t.o feature/patternLong.t.o \
 	feature/threatmate.t.o
 OPENING_OBJS = openingBook.t.o
-
+MOVE_PROBABILITY_OBJS = feature.t.o featureSet.t.o moveInfo.t.o \
+	stateInfo.t.o
 MISC_OBJS = 
 
 # qualified objects
@@ -115,7 +116,8 @@
 	$(patsubst %.o,checkmate/%.o,$(CHECKMATE_OBJS)) \
 	$(patsubst %.o,game_playing/%.o,$(GAME_PLAYING_OBJS)) 
 Q_NTESUKI_OBJS = $(patsubst %.o,ntesuki/%.o,$(NTESUKI_OBJS))
-Q_RATING_OBJS = $(patsubst %.o,rating/%.o,$(RATING_OBJS))
+Q_RATING_OBJS = $(patsubst %.o,rating/%.o,$(RATING_OBJS)) \
+	$(patsubst %.o,move_probability/%.o,$(MOVE_PROBABILITY_OBJS))
 Q_OPENING_OBJS = $(patsubst %.o,record/opening/%.o,$(OPENING_OBJS))
 TEST_OBJS = $(BOARD_OBJS) $(Q_SEARCH_OBJS) $(Q_OPENING_OBJS) \
  $(MISC_OBJS) $(Q_RATING_OBJS)
@@ -139,7 +141,7 @@
 testAll: $(OBJS) $(FILE_OSL_ALL)
 	mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
 	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES) 
-testLong: testOne.o $(TEST_OBJS) $(FILE_OSL_ALL)
+testLong: testLong.o $(TEST_OBJS) $(FILE_OSL_ALL)
 	-@mkdir -p `dirname $(OUTPUTPREFIX)$@` > /dev/null 2>&1
 	$(CXX) $(LDFLAGS) -o $(OUTPUTPREFIX)$@ $^ $(LOADLIBES)

=== debian/changelog ===
libosl (0.4.2-1) unstable; urgency=low

  * New upstream release (OSL r4384).
    (Closes: #633470, #633473)

 -- Daigo Moriwaki <daigo@debian.org>  Mon, 10 Oct 2011 12:11:29 +0900

libosl (0.4.1-1) unstable; urgency=low

  * New upstream release (OSL r4380).
  * debian/rules: Added a new target: get-orig-source.

 -- Daigo Moriwaki <daigo@debian.org>  Fri, 07 Oct 2011 20:13:34 +0900

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libosl
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Daigo Moriwaki <daigo@debian.org>
+Maintainer: Daigo Moriwaki <daigo@debian.org>
 Build-Depends: cdbs, debhelper (>= 7), libcppunit-dev (>= 1.10.2-5), libboost1.46-all-dev
 Standards-Version: 3.9.2
 Homepage: http://gps.tanaka.ecc.u-tokyo.ac.jp/gpsshogi/pukiwiki.php

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,11 @@
 #!/usr/bin/make -f
+
+SOURCE = $(shell dpkg-parsechangelog | grep "^Source" | sed "s/Source: //")
+VERSION = $(shell dpkg-parsechangelog | grep "^Version" | sed "s/Version: //")
+ORIG_VERSION = $(shell echo $(VERSION) | sed "s/-.*//")
+PRISTINE_VERSION = $(shell echo $(ORIG_VERSION) | sed "s/\+dfsg//")
+UPSTREAM_VERSION = $(shell echo $(PRISTINE_VERSION) | sed "s/^0\.0\.//")
+SRCDIR_NAME = $(SOURCE)-$(ORIG_VERSION).orig
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 
@@ -20,22 +27,19 @@
 DEB_INSTALL_DIRS_libosl-doc += usr/share/doc/libosl-doc
 DEB_INSTALL_DOCS_libosl-doc += doc/html
 
-
 pre-build::
 	cp $(CURDIR)/debian/makefile.local.$(DEB_HOST_ARCH_CPU) $(CURDIR)/makefile.local
 
 build/libosl$(so_ver)::
 	$(MAKE) -C release-so make-directories
-# unused-but-set-variable disable until 633473 is fixed
-	$(MAKE) -C release-so WARN_UNUSED="-Wno-error=unused-but-set-variable -Wno-unused-parameter" PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" $(DEB_MAKE_PARALLEL) libosl.so.$(so_ver).0
+	$(MAKE) -C release-so PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" $(DEB_MAKE_PARALLEL) libosl.so.$(so_ver).0
 
 binary-install/libosl$(so_ver)::
 	dh_install -p$(cdbs_curpkg) --sourcedir=release-so libosl.so.* usr/lib
 
 build/libosl-dev::
 	$(MAKE) -C release make-directories
-# unused-but-set-variable disable until 633473 is fixed
-	$(MAKE) -C release WARN_UNUSED="-Wno-error=unused-but-set-variable -Wno-unused-parameter" PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" $(DEB_MAKE_PARALLEL) all
+	$(MAKE) -C release PROF=-g OSL_PUBLIC_RELEASE=t OSL_HOME_FLAGS=-DOSL_HOME=\\\"/usr/share/gpsshogi-data\\\" $(DEB_MAKE_PARALLEL) all
 
 binary-install/libosl-dev::
 	dh_install -p$(cdbs_curpkg) --sourcedir=release lib*.a usr/lib
@@ -49,3 +53,19 @@
 	$(MAKE) -C release-so clean
 	-rm release-so/libosl.so*
 	-rm -f $(CURDIR)/makefile.local
+
+get-orig-source:
+	if [ ! -f osl.tar.gz ] ; then \
+	  wget "http://gps.tanaka.ecc.u-tokyo.ac.jp/cgi-bin/viewvc.cgi/trunk/osl.tar.gz" ; \
+	fi
+	mkdir debian/$(SRCDIR_NAME)
+	cd debian/$(SRCDIR_NAME) && tar xzvf ../../osl.tar.gz
+	if test "`ls debian/$(SRCDIR_NAME) | wc -l`" -eq "1" ; then \
+		subdir=`echo debian/$(SRCDIR_NAME)/*` && \
+		mv $$subdir/* $$subdir/.??* debian/$(SRCDIR_NAME) && \
+		rmdir $$subdir ; \
+	fi
+	rm -rf debian/$(SRCDIR_NAME)/lib/third_party
+	rm -rf debian/$(SRCDIR_NAME)/public-domain
+	tar czf ../$(SOURCE)_$(ORIG_VERSION).orig.tar.gz -C debian $(SRCDIR_NAME)
+	rm -rf debian/$(SRCDIR_NAME)
